/********************************************************************/
/*                                                                  */
/*                         MENUDEMO.C                               */
/*                                                                  */
/*   A demo program for the DROPMENU & SETDCOL Shareware routines   */
/*                                                                  */
/*               Copyright 1990, Denam Systems                      */
/*                     Dennis R. Fischer                            */
/*                                                                  */
/********************************************************************/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <alloc.h>
#include "dropmenu.h"
#include "setdcol.h"

extern unsigned _stklen=10000;

BOOLEAN casesense;   /* switch to determine case sensitivity */
char    *helpbuf;    /* screen save buffer */
int     midy=12;     /* horz. middle of the screen */

void shownotimplemented (char *notice)
{
	char *buf;

	buf = (char *) malloc (44*18*2);
	if (buf != NULL) gettext (18, 5, 61, 22, buf);
	selectioninfoscreen (notice);
	gotoxy (32, 12);
	cputs ("Not Implemented");
	textbackground (4);  /* red */
	infoscreenoptions ("Press Any Key To Continue");
	(void)getch();
	if (buf != NULL) {
		puttext (18, 5, 61, 22, buf);
		free (buf);
	}
}   /* shownotimplemented */


void near make_info_screen (char *notice)
{
	cursoroff();
	helpbuf = (char *) malloc (42*22*2);
	if (helpbuf != NULL) gettext (18, 3, 60, 23, helpbuf);
	textcolor (InfoBoxColor);
	textbackground (InfoBackColor);
	noticebox (notice, 19, midy-9, 40, 20, TRUE, TRUE);
	if (currentdisplay() == monochromecolor)
		textbackground (BLACK);
	else
		textbackground (RED);
	textcolor (WHITE);
	gotoxy (20, midy + 8);
	cputs ("       Press Any Key To Continue      ");
	textcolor (InfoWriteColor);
	textbackground (InfoBackColor);
}	/* make_info_screen */

void near make_plain_screen(void)
{
	cursoroff();
	helpbuf = (char *) malloc (42*22*2);
	if (helpbuf != NULL) gettext (18, 3, 60, 23, helpbuf);
	textcolor (InfoBoxColor);
	textbackground (InfoBackColor);
	noticebox ("", 19, midy-9, 40, 20, TRUE, TRUE);
	if (currentdisplay() == monochromecolor)
		textbackground (BLACK);
	else
		textbackground (RED);
	textcolor (WHITE);
	gotoxy (20, midy + 8);
	cputs ("       Press Any Key To Continue      ");
	textcolor (InfoWriteColor);
	textbackground (InfoBackColor);
}	/* make_plain_screen */

void near stop_help (void)
{
	(void) getch();
	if (helpbuf != NULL) {
		puttext (18, 3, 60, 23, helpbuf);
		free (helpbuf);
	}
	else {
		/* Just incase there was no buffer to save the screen */
		window (1, 2, 80, 25);
		textbackground (ScreenBackColor);
		clrscr();
		window (1, 1, 80, 25);
   }
}   /* stop_help */

void showcopyright(void)
{
	/* show modify by category help */
	make_plain_screen ();
	gotoxy (21, midy - 6);
	cputs ("      DROPMENU & SETDCOL DEMO");
	gotoxy (21, midy - 5);
	cputs ("     Version 2.03     05/02/90");
	gotoxy (21, midy - 3);
	cputs (" Routines to assist the programmer");
	gotoxy (21, midy - 2);
	cputs ("   in developing dropdown menus.");
	gotoxy (21, midy+1);
	cputs ("     Written entirely in Borland");
	gotoxy (21, midy + 2);
	cputs ("     International's Turbo C 2.0");
	gotoxy (21, midy + 4);
	cputs (" ** Custom Programming Available **");
	gotoxy (21, midy + 6);
	cputs ("    Copyright 1990, Denam Systems");
	stop_help();
}   /* showcopyright */

void showshareware(void)
{
	/* show modify by category help */
	make_plain_screen ();
	gotoxy (21, midy - 7);
	/* loc 48 is max */
	cputs ("             SHAREWARE");
	gotoxy (21, midy - 6);
	cputs ("DROPMENU is distributed as Shareware.");
	gotoxy (21, midy - 5);
	cputs ("As such, you may freely copy and");
	gotoxy (21, midy - 4);
	cputs ("pass along this program to bulletin");
	gotoxy (21, midy - 3);
	cputs ("boards, friends, and etc.  Try it");
	gotoxy (21, midy - 2);
	cputs ("out and if it fits your needs, $20");
	gotoxy (21, midy - 1);
	cputs ("registers it, providing you with");
	gotoxy (21, midy);
	cputs ("free support and the source code.");
	gotoxy (21, midy + 3);
	cputs ("          Denam Systems");
	gotoxy (21, midy + 4);
	cputs ("   1115 Madison St. NE  Suite 226");
	gotoxy (21, midy + 5);
	cputs ("       Salem, Oregon  97303");
	gotoxy (21, midy + 6);
	cputs ("         (503) 363-0198");
	gotoxy (21, midy + 7);
	cputs ("      CompuServe 70405,1422");
	stop_help();
}   /* showshareware */

void showhelp (char *notice)
{
	char *buf;

	buf = (char *) malloc (44*18*2);
	if (buf != NULL) gettext (18, 5, 61, 22, buf);
	selectioninfoscreen (notice);
	gotoxy (32, 12);
	cputs ("Not Implemented");
	textbackground (4);  /* red */
	infoscreenoptions ("Press Key To Return To Menu");
	(void)getch();
	if (buf != NULL) {
		puttext (18, 5, 61, 22, buf);
		free (buf);
	}
}   /* showhelp */

BOOLEAN ask_for_op_save (char *notice, char *secondnotice)
{
	char    *buf;
	char    ts[81];
	BYTE    loc;
	BOOLEAN saveit;
	char    ch;

	/* subroutine for the setcasesensitive() routine */
	buf = (char *) malloc (50*10*2);
	if (buf != NULL) gettext (17, 4, 66, 13, buf);
	textcolor(NoticeBoxColor);
	textbackground(NoticeBackColor);
	noticebox ("", 31, 4, 22, 3, TRUE, FALSE);
	textcolor(NoticeWriteColor);
	gotoxy (42-(strlen(secondnotice)/2), 5);
	cputs (secondnotice);
	strcpy (ts, " Save '");
	strcat (ts, notice);
	strcat (ts, "' Option Setting (Y/N)");
	loc=(int)42-(strlen(ts)/2);
	if (loc<19) loc=19;
  textcolor (AskBoxColor);
  textbackground (AskBackColor);
	noticebox ("", 18, 10, 49, 3, TRUE, FALSE);
	textcolor (AskWriteColor);
	gotoxy (loc, 11); cputs (ts);
	saveit=FALSE;
	do{
		ch=getch();
		if ((ch=='Y') || (ch=='y') || (ch=='N') || (ch=='n')) saveit=TRUE;
	}while (!saveit);
	if ((ch=='Y') || (ch=='y')) saveit=TRUE; else saveit=FALSE;
	if (buf != NULL) {
		puttext (17, 4, 66, 13, buf);
      free (buf);
	}
	return(saveit);
}   /* ask_for_op_save */

void setcasesensitive (void)
{
	BOOLEAN saveit;
	char    ts[20];

	/* Sets the Options/Search Type (Top6Place0) display menu
		 depending on the type of search that is selected */

	casesense = !casesense;
	if (!casesense)
		strcpy (SelectNames[6][0], "Search Type (NOT CASE SENSITIVE)");
	else
		strcpy (SelectNames[6][0], "Search Type (CASE SENSITIVE)    ");
	if (casesense)
		strcpy (ts, "CASE SENSITIVE");
	else
		strcpy (ts, "NOT CASE SENSITIVE");
	saveit=ask_for_op_save("Search Type", ts);
	if (saveit) {
		 /* save to data file */
	}
}   /* setcasesensitive */

BOOLEAN setmenu(void)
{
	BOOLEAN menu_was_set;

	nulmenuvars();   /* nul all the menu stuff */

	/* Set the general catagories that will be
		 displayed on the top line */
	settopname ("General");
	settopname ("Add");
	settopname ("Modify");
	settopname ("List");
	settopname ("Print");
	settopname ("Delete");
	settopname ("Options");
	settopname ("User");

	/* Submenu selection of General catagory */
	setselectname (0, 0, "Info", 9);
	setselectname (0, 1, "Shareware", 9);
	setselectname (0, 2, "Quit", 9);

	/* Submenu selection of Add catagory */
	setselectname (1, 0, "Add Item", 8);

	/* Submenu selection of Modify catagory */
	setselectname (2, 0, "All", 13);
	setselectname (2, 1, "Category", 13);
	setselectname (2, 2, "Date", 13);
	setselectname (2, 3, "Item", 13);
	setselectname (2, 4, "Narrative", 13);
	setselectname (2, 5, "Room", 13);
	setselectname (2, 6, "Serial Number", 13);
	setselectname (2, 7, "Vendor", 13);

	/* Submenu selections of List catagory */
	setselectname (3, 0, "All", 13);
	setselectname (3, 1, "Category", 13);
	setselectname (3, 2, "Date", 13);
	setselectname (3, 3, "Item", 13);
	setselectname (3, 4, "Narrative", 13);
	setselectname (3, 5, "Room", 13);
	setselectname (3, 6, "Serial Number", 13);
	setselectname (3, 7, "Vendor", 13);

	/* Submenu selections of Print catagory */
	setselectname (4, 0, "All", 13);
	setselectname (4, 1, "Category", 13);
	setselectname (4, 2, "Date", 13);
	setselectname (4, 3, "Item", 13);
	setselectname (4, 4, "Narrative", 13);
	setselectname (4, 5, "Room", 13);
	setselectname (4, 6, "Serial Number", 13);
	setselectname (4, 7, "Vendor", 13);

	/* Submenu selections of Delete catagory */
	setselectname (5, 0, "All", 13);
	setselectname (5, 1, "Category", 13);
	setselectname (5, 2, "Date", 13);
	setselectname (5, 3, "Item", 13);
	setselectname (5, 4, "Narrative", 13);
	setselectname (5, 5, "Room", 13);
	setselectname (5, 6, "Serial Number", 13);
	setselectname (5, 7, "Vendor", 13);

	/* Submenu selection of Options catagory */
	casesense=FALSE;
	setselectname (6, 0, "Search Type (NOT CASE SENSITIVE)", 32);

	/* Submenu selection of User catagory */
	setselectname (7, 0, "Set Colors", 10);

	menu_was_set = setmenupicks();   /* put menu info in proper places */
	if (menu_was_set) {
		setdefaultmenucolors();        /* set default colors */
    textbackground (ScreenBackColor);
		clrscr();
		setbordercolor(BLACK);
		ShadowedMenu = TRUE;           /* dropdown submenus will have border */
		cursoroff();
		drawtopline();                 /* display general menu catagories */
	}
	return (menu_was_set);
}   /* setmenu */


main ()
{
	BOOLEAN  isinfo;               /* user asked for help screen */
	BOOLEAN  quitprogram=FALSE;    /* quit program */
	BOOLEAN  colorchanged;         /* user changed screen colors */

	clrscr();
	if (setmenu()) {
		do {
			MenuSelection = getmenuselection(&isinfo);   /* get menu pick */
			colorchanged=FALSE;
			if (!isinfo) {
				switch (MenuSelection) {
					case Top0Place0 : showcopyright(); break;
					case Top0Place1 : showshareware(); break;
					case Top0Place2 : quitprogram = TRUE; break;

					case Top1Place0 : shownotimplemented("Add Routine"); break;

					case Top2Place0 : ;
					case Top2Place1 : ;
					case Top2Place2 : ;
					case Top2Place3 : ;
					case Top2Place4 : ;
					case Top2Place5 : ;
					case Top2Place6 : ;
					case Top2Place7 : shownotimplemented("Modify Routines"); break;

					case Top3Place0 : ;
					case Top3Place1 : ;
					case Top3Place2 : ;
					case Top3Place3 : ;
					case Top3Place4 : ;
					case Top3Place5 : ;
					case Top3Place6 : ;
					case Top3Place7 : shownotimplemented("List Routines"); break;

					case Top4Place0 : ;
					case Top4Place1 : ;
					case Top4Place2 : ;
					case Top4Place3 : ;
					case Top4Place4 : ;
					case Top4Place5 : ;
					case Top4Place6 : ;
					case Top4Place7 : shownotimplemented("Print Routines"); break;

					case Top5Place0 : ;
					case Top5Place1 : ;
					case Top5Place2 : ;
					case Top5Place3 : ;
					case Top5Place4 : ;
					case Top5Place5 : ;
					case Top5Place6 : ;
					case Top5Place7 : shownotimplemented("Delete Routines"); break;

					case Top6Place0 : setcasesensitive();            break;

					case Top7Place0 : colorchanged = setmenucolor(); break;

					default         : break;
				}
			}
			else {
				/* user asked for info by pressing F1 key at menu */
				switch (MenuSelection) {
					case Top0Place0 : ;
					case Top0Place1 : ;
					case Top0Place2 : ;

					case Top1Place0 : ;
					case Top1Place1 : ;

					case Top2Place0 : ;
					case Top2Place1 : ;
					case Top2Place2 : ;
					case Top2Place3 : ;
					case Top2Place4 : ;
					case Top2Place5 : ;
					case Top2Place6 : ;
					case Top2Place7 : ;

					case Top3Place0 : ;
					case Top3Place1 : ;
					case Top3Place2 : ;
					case Top3Place3 : ;
					case Top3Place4 : ;
					case Top3Place5 : ;
					case Top3Place6 : ;
					case Top3Place7 : ;

					case Top4Place0 : ;
					case Top4Place1 : ;
					case Top4Place2 : ;
					case Top4Place3 : ;
					case Top4Place4 : ;
					case Top4Place5 : ;
					case Top4Place6 : ;
					case Top4Place7 : ;

					case Top5Place0 : ;
					case Top5Place1 : ;
					case Top5Place2 : ;
					case Top5Place3 : ;
					case Top5Place4 : ;
					case Top5Place5 : ;
					case Top5Place6 : ;
					case Top5Place7 : ;

					case Top6Place0 : ;

					case Top7Place0 : showhelp("This is a help file"); break;

					default         : break;
				}
			}
			if (colorchanged) {
				 /* put your stuff here */
			}
		} while (!quitprogram);
  }
	textbackground(0);
	clrscr();
	cursoron();
}
